"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextStyleResolver = void 0;
/* eslint-disable no-console */
const react_1 = __importStar(require("react"));
const react_2 = require("@gluestack-style/react");
const react_native_1 = require("react-native");
const textStyles = [
    'color',
    'fontFamily',
    'fontSize',
    'fontStyle',
    'fontWeight',
    'includeFontPaddingAndroid',
    'fontVariant',
    'letterSpacing',
    'lineHeight',
    'textAlign',
    'textAlignVerticalAndroid',
    'textDecorationColoriOS',
    'textDecorationLine',
    'textDecorationStyleiOS',
    'textShadowColor',
    'textShadowOffset',
    'textShadowRadius',
    'textTransform',
    'verticalAlignAndroid',
    'writingDirectioniOS',
    'userSelect',
];
class TextStyleResolver {
    // no other use
    register() { }
    constructor() {
        this.name = 'TextStyleResolver';
    }
    // @ts-ignore
    inputMiddleWare(_styledObj = {}, _shouldUpdate = true, _ = false, Component, ...args) {
        var _a;
        if (_shouldUpdate)
            this.themed = _styledObj;
        (_a = args === null || args === void 0 ? void 0 : args[1]) === null || _a === void 0 ? true : delete _a.plugins;
        this.styledComponentConfig = args;
        return [_styledObj, _shouldUpdate, _, Component];
    }
    componentMiddleWare(_a) {
        var { Component, styleCSSIds, GluestackStyleSheet } = _a, rest = __rest(_a, ["Component", "styleCSSIds", "GluestackStyleSheet"]);
        const styles = [];
        console.log('GluestackStyleSheet', GluestackStyleSheet);
        console.log('rest', rest);
        const nativeStyleMap = GluestackStyleSheet.getStyleMap();
        styleCSSIds.forEach((cssId) => {
            const nativeStyle = nativeStyleMap.get(cssId);
            if (nativeStyle) {
                console.log('nativeStyle', nativeStyle);
                const styleSheet = nativeStyle === null || nativeStyle === void 0 ? void 0 : nativeStyle.resolved;
                if (styleSheet && textStyles.includes(Object.keys(styleSheet)[0]))
                    styles.push(styleSheet);
            }
        });
        const stylesObj = react_native_1.StyleSheet.flatten(styles);
        console.log('stylesObj', stylesObj);
        const StyledComponent = (0, react_2.styled)(Component, {}, ...this.styledComponentConfig);
        // console.log('styled', this.styledComponentConfig);
        const TextAncestorContext = (0, react_1.createContext)({
            hasTextAncestor: false,
            propsPassed: {},
        });
        const TextStyledResolvedComponent = (0, react_1.forwardRef)((_a, ref) => {
            var { key } = _a, componentProps = __rest(_a, ["key"]);
            const { hasTextAncestor, propsPassed } = (0, react_1.useContext)(TextAncestorContext);
            let finalProps = componentProps;
            if (hasTextAncestor) {
                finalProps = Object.assign(Object.assign({}, propsPassed), componentProps);
                console.log('finalProps', finalProps);
            }
            return (react_1.default.createElement(TextAncestorContext.Provider, { value: {
                    hasTextAncestor: true,
                    // propsPassed: stylesObj,
                    propsPassed: {},
                } },
                react_1.default.createElement(StyledComponent, Object.assign({}, componentProps, { key: key, ref: ref }))));
        });
        return TextStyledResolvedComponent;
    }
}
exports.TextStyleResolver = TextStyleResolver;
